app.py
from flask import Flask, redirect, url_for, jsonify, session, request, render_template,g
from flask_dance.contrib.google import google
from routes.auth import auth, blueprint, admin_required
from routes.services import services
from routes.admin_panel import admin_panel

app = Flask(__name__)
app.secret_key = "aled"
app.register_blueprint(auth)
app.register_blueprint(blueprint, url_prefix="/login")
app.register_blueprint(services, url_prefix='/services')
app.register_blueprint(admin_panel, url_prefix='/admin')

@app.route("/")
def index():
    return render_template("index.html", connected=google.authorized, pp=session.get("profile_img_url","no_image"))

@app.route("/profile")
def profile():
    if not google.authorized:
        return redirect(url_for("google.login"))

    resp = google.get("/oauth2/v2/userinfo")
    if not resp.ok:
        return jsonify({"error": "Failed to fetch user info from Google."}), 400

    return jsonify(resp.json())


@app.route('/about')
def about():
    return render_template("about.html", connected=google.authorized, pp=session.get("profile_img_url","no_image"))



# DB PART


@app.teardown_appcontext
def close_connection(exception):
    db = getattr(g, '_database', None)
    if db is not None:
        db.close()


if __name__ == "__main__":
    #with app.app_context():
    #    init_debug_db()
    app.run()

routes/admin_panel.py
from flask import Blueprint, session, redirect, url_for, flash, render_template, request
from flask_dance.contrib.google import google
from routes.auth import admin_required
from utils.db import *
admin_panel = Blueprint('admin_panel', __name__)


@admin_panel.route("/panel")
@admin_required
def panel():
    return render_template("admin.html")

"""
def get_pending_requests():
    with admin_panel.app_context():
        db = get_db()
"""

@admin_panel.route("/emprunts")
@admin_required
def emprunts(action=None, loan_id=None):
    action = request.args.get('action')
    loan_id = request.args.get('loan_id')
    if action and loan_id:
        if action == 'accept':
            accept_loan(loan_id)
            redirect(url_for('admin_panel.emprunts'))
        if action == 'reject':
            delete_loan(loan_id)
            redirect(url_for('admin_panel.emprunts'))
        if action == 'return':
            delete_loan(loan_id)
            redirect(url_for('admin_panel.emprunts'))


    ongoing = get_ongoing_loans()
    late = get_late_loans()
    pending = get_pending_loans()
    items = get_items_dict()
    places = get_places()
    return render_template("admin_emprunts.html", ongoing=ongoing, late=late, pending=pending, items=items, places=places)

routes/auth.py
from flask import Blueprint, session, redirect, url_for, flash
from flask_dance.contrib.google import make_google_blueprint, google
from functools import wraps
from flask_dance.consumer import oauth_authorized
from dotenv import load_dotenv
load_dotenv()

import os
ADMIN_USERS = ["lotcelan@gmail.com"]


auth = Blueprint('auth', __name__)

client_id = os.environ.get("GOOGLE_CLIENT_ID")
client_secret = os.environ.get("GOOGLE_CLIENT_SECRET")

blueprint = make_google_blueprint(
    client_id=client_id,
    client_secret=client_secret,
    scope=["profile", "email"],

)

def admin_required(f):

    @wraps(f)
    def decorated_function(*args, **kwargs):
        if session.get('is_admin') is not True:
            flash("You are not admin !", category="error")
            return redirect(url_for('index'))
        return f(*args, **kwargs)
    return decorated_function

@auth.route("/authenticate")
def authenticate():
    return redirect(url_for("google.login"))

"""
@auth.route("/")
def index():
    if not google.authorized:
        return redirect(url_for("google.login"))
    resp = google.get("/oauth2/v2/userinfo")
    assert resp.ok, resp.text
    return f"Welcome, {resp.json()['name']}!"
"""

@auth.route("/logout")
def logout():
    token = blueprint.token  # Get the current token

    if token is not None:
        # Delete the token
        del blueprint.token

    # You can also use Flask's session to remove user details if you have stored any
    session.clear()

    return redirect(url_for("index"))

@oauth_authorized.connect_via(blueprint)
def google_logged_in(blueprint, token):
    if not token:
        flash("Failed to log in with Google.", category="error")
        return False

    resp = blueprint.session.get("/oauth2/v2/userinfo")
    if not resp.ok:
        msg = "Failed to fetch user info from Google."
        flash(msg, category="error")
        return False


    info = resp.json()
    print(info)
    flash(f"Welcome {info['name']}")
    
    session["profile_img_url"] = info["picture"]
    session["email"] = info["email"]
    # Check if the user is an admin

    print(f"{info['email']=}")
    if info["email"] in ADMIN_USERS:
        session['is_admin'] = True
    else:
        session['is_admin'] = False

routes/services.py
from flask import Blueprint, session, redirect, url_for, flash, render_template, request, current_app
from flask_dance.contrib.google import google
from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField, SelectField, DateTimeLocalField, RadioField, BooleanField
from wtforms.validators import DataRequired, Length
from utils.db import add_loan, get_items_dict

services = Blueprint('services', __name__)

class EmpruntBDEForm(FlaskForm):
    # Todo : validators
    #item_select = SelectField('Item', choices=[("-1", "Nouvel Item")], )
    item_select = SelectField('Item', choices=[])
    sous = StringField('Sous : BDE/CLUB')
    #custom_item_select_name = StringField('Nouveau nom d\'item',  )
    #custom_item_select_place= StringField('Nouveau nom d\'item',  )
    date_debut = DateTimeLocalField('Date du début de l\'emprunt',   )
    date_fin = DateTimeLocalField('Date de la fin de l\'emprunt',   )
    caution = RadioField("La caution est", choices=[(0,"le chèque de cuation donné lors de l'inscription"),(1,"un chèque à donner au BDE")])
    accept = BooleanField("J'accepte les conditions décrites plus haut et que le CETEN se réserve le choix du montant en cas de casse de l'appareil, en fonction des dommages engendrés")
    submit = SubmitField('Envoyer la demande', render_kw={'type':'submit'})

@services.route("/emprunt_bde", methods=["POST","GET"])
def emprunt_bde():
    if not google.authorized:
        return redirect(url_for("google.login"))
    
    form = EmpruntBDEForm()
    form.item_select.choices = form.item_select.choices + [(id, o['name']) for id, o in get_items_dict().items()]

    if form.validate_on_submit():
        with current_app.app_context():
            add_loan(session['email'], form.item_select.data,form.date_debut.data, form.date_fin.data,form.sous.data, form.caution.data)
        flash('Demande faite!', 'success')
        return redirect(url_for('services.emprunt_bde')) 
    else:
        print(form.errors)
    return render_template("emprunt_bde.html", connected=google.authorized, pp=session.get("profile_img_url","no_image"), form=form)

@services.route('/index')
def index():
    if not google.authorized:
        return redirect(url_for("google.login"))
    
    return render_template("services.html", connected=google.authorized, pp=session.get("profile_img_url","no_image"))

templates/about.html
{% extends "base.html" %}

{% block section_title %}About{% endblock %}

{% block content %}
<p>Ce site sert aux clubs et membres du CETEN à voir ce qui est empruntable, et à faire les demandes pour des emprunts !
D'autres fonctionnalités comme les agendas (gestion et visualisation) sont prévues :)</p>
{% endblock %}

templates/admin.html
{% extends "base.html" %}

{% block section_title %}Admin panel{% endblock %}


{% block content %}
<p>Différents services sont proposés en ligne :</p>
<ul>
    <li>
        <a href="{{ url_for('admin_panel.emprunts') }}">Gestion des emprunts</a>
    </li>
</ul>
{% endblock %}

templates/admin_emprunts.html
{% extends "base.html" %}

{% block section_title %}Admin panel - Emprunts{% endblock %}
{% block custom_head %} <link rel="stylesheet" type="text/css" href="{{url_for('static', filename='styles/admin_emprunt.css')}}">{% endblock %}

{% block content %}
<div class="cartes-container">
    <div class="zone" id="demandes-emprunt">
        <h3>Demandes d'emprunt</h3>
        {% for l in pending %}
        <div class="carte">
            <div class="carte-header">
                <h3>{{ items[l[2]]['name'] }}</h3>
            </div>
            <div class="carte-content">
                <p style="font-style: italic; color:gray; font-size: smaller;">Emprunt n°{{ l[0]}}</p>
                <p>Emprunteur: {{l[1]}}</p>
                <p>Lieu: {{places[items[l[2]]['place_id']]['name']}}</p>
                <p>Date de début: {{l[3]}}</p>
                <p>Date de fin: {{l[4]}}</p>
                <p>Caution: {% if l[6] == 0 %}Celle du CETEN{% elif l[6] == 1 %}Custom{% else %}WTF?{% endif %}</p>
            </div>
            <div class="carte-buttons">
                <button class="accept-button" onclick="window.location.href=`{{url_for('admin_panel.emprunts')}}?action=accept&loan_id={{l[0]}}`">Accepter</button>
                <button class="reject-button" onclick="window.location.href=`{{url_for('admin_panel.emprunts')}}?action=reject&loan_id={{l[0]}}`">Refuser</button>
                <button class="reject-caution-button" onclick="window.location.href=`{{url_for('admin_panel.emprunts')}}?action=reject&loan_id={{l[0]}}`">Refuser - Demande de caution particulière</button>
            </div>
        </div>
        {% endfor %}
    </div>

    <div class="zone" id="en-cours">
        <h3>Emprunts en cours</h3>

        {% for l in ongoing %}
        <div class="carte">
            <div class="carte-header">
                <h3>{{ items[l[2]]['name'] }}</h3>
            </div>
            <div class="carte-content">
                <p style="font-style: italic; color:gray; font-size: smaller;">Emprunt n°{{ l[0]}}</p>
                <p>Emprunteur: {{l[1]}}</p>
                <p>Lieu: {{places[items[l[2]]['place_id']]['name']}}</p>
                <p>Date de début: {{l[3]}}</p>
                <p>Date de fin: {{l[4]}}</p>
                <p>Caution: {% if l[6] == 0 %}Celle du CETEN{% elif l[6] == 1 %}Custom{% elif l[6] == 2 %}En attente du chèque{% elif l[6] == 3 %}Chèque donné !{% else %}WTF?{% endif %}</p>
            </div>
            <div class="carte-buttons">
                <button class="return-button" onclick="window.location.href=`{{url_for('admin_panel.emprunts')}}?action=return&loan_id={{l[0]}}`">Rendu</button>
                {% if l[6] == 2 %}
                <button class="pending-caution-button" onclick="window.location.href=`{{url_for('admin_panel.emprunts')}}?action=caution_validate&loan_id={{l[0]}}`">Caution donnée</button>
                {% endif %}
            </div>
        </div>
        {% endfor %}
    </div>


    <div class="zone" id="en-retard">
        <h3>Emprunts en retard</h3>
        {% for l in late %}
        <div class="carte">
            <div class="carte-header">
                <h3>{{ items[l[2]]['name'] }}</h3>
            </div>
            <div class="carte-content">
                <p style="font-style: italic; color:gray; font-size: smaller;">Emprunt n°{{ l[0]}}</p>
                <p>Emprunteur: {{l[1]}}</p>
                <p>Lieu: {{places[items[l[2]]['place_id']]['name']}}</p>
                <p>Date de début: {{l[3]}}</p>
                <p>Date de fin: {{l[4]}}</p>
                <p>Caution: {% if l[6] == 0 %}Celle du CETEN{% elif l[6] == 1 %}Custom{% elif l[6] == 2 %}En attente du chèque{% elif l[6] == 3 %}Chèque donné !{% else %}WTF?{% endif %}</p>
            </div>
            <div class="carte-buttons">
                <button class="return-button" onclick="window.location.href=`{{url_for('admin_panel.emprunts')}}?action=return&loan_id={{l[0]}}`">Rendu</button>
                {% if l[6] == 2 %}
                <button class="pending-caution-button" onclick="window.location.href=`{{url_for('admin_panel.emprunts')}}?action=caution_validate&loan_id={{l[0]}}`">Caution donnée</button>
                {% endif %}
            </div>
        </div>
        {% endfor %}
    </div>
</div>
{% endblock %}

templates/base.html
<!DOCTYPE html>
<html>
<head>
    <title>Home</title>
    <link rel="stylesheet" type="text/css" href="{{url_for('static', filename='styles/nav.css')}}">
    <link rel="stylesheet" type="text/css" href="{{url_for('static', filename='styles/base.css')}}">
    {% block custom_head %}{% endblock %}
</head>
<body>
    <!-- Navbar -->
<nav id="navbar">
    <ul class="navbar-items flexbox-col">
      <li class="navbar-logo flexbox-left">
        <a class="navbar-item-inner flexbox">
            <svg width="800px" height="800px" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path fill-rule="evenodd" clip-rule="evenodd" d="M4.17157 3.17157C3 4.34315 3 6.22876 3 10V14C3 17.7712 3 19.6569 4.17157 20.8284C5.34315 22 7.22876 22 11 22H13C16.7712 22 18.6569 22 19.8284 20.8284C21 19.6569 21 17.7712 21 14V10C21 6.22876 21 4.34315 19.8284 3.17157C18.6569 2 16.7712 2 13 2H11C7.22876 2 5.34315 2 4.17157 3.17157ZM12.75 6C12.75 5.58579 12.4142 5.25 12 5.25C11.5858 5.25 11.25 5.58579 11.25 6V7.25H9.99997C9.58575 7.25 9.24997 7.58579 9.24997 8C9.24997 8.41421 9.58575 8.75 9.99997 8.75H11.25L11.25 10C11.25 10.4142 11.5858 10.75 12 10.75C12.4142 10.75 12.75 10.4142 12.75 10L12.75 8.75L14 8.75C14.4142 8.75 14.75 8.41421 14.75 8C14.75 7.58579 14.4142 7.25 14 7.25H12.75V6ZM8 13.25C7.58579 13.25 7.25 13.5858 7.25 14C7.25 14.4142 7.58579 14.75 8 14.75H16C16.4142 14.75 16.75 14.4142 16.75 14C16.75 13.5858 16.4142 13.25 16 13.25H8ZM9 17.25C8.58579 17.25 8.25 17.5858 8.25 18C8.25 18.4142 8.58579 18.75 9 18.75H15C15.4142 18.75 15.75 18.4142 15.75 18C15.75 17.5858 15.4142 17.25 15 17.25H9Z" fill="#ffffff"/>
                </svg>
        </a>
      </li>
      <li class="navbar-item flexbox-left">
        <a class="navbar-item-inner flexbox-left" href="{{url_for('index')}}">
          <div class="navbar-item-inner-icon-wrapper flexbox">
            <ion-icon name="search-outline"></ion-icon>
          </div>
          <span class="link-text">Home</span>
        </a>
      </li>
      <li class="navbar-item flexbox-left">
        <a class="navbar-item-inner flexbox-left" href="{{url_for('about')}}">
          <div class="navbar-item-inner-icon-wrapper flexbox">
            <ion-icon name="home-outline"></ion-icon>
          </div>
          <span class="link-text">About</span>
        </a>
      </li>
      <li class="navbar-item flexbox-left">
        <a class="navbar-item-inner flexbox-left" href="{{url_for('services.index')}}">
          <div class="navbar-item-inner-icon-wrapper flexbox">
            <ion-icon name="folder-open-outline"></ion-icon>
          </div>
          <span class="link-text">Services</span>
        </a>
      </li>
      <li class="navbar-item flexbox-left">
        <a class="navbar-item-inner flexbox-left" href="{{url_for('admin_panel.panel')}}">
          <div class="navbar-item-inner-icon-wrapper flexbox">
            <ion-icon name="folder-open-outline"></ion-icon>
          </div>
          <span class="link-text">Admin panel</span>
        </a>
      </li>
      <li class="navbar-item flexbox-left">
        {% if not connected %}
            <a class="navbar-item-inner flexbox-left" href="{{url_for('auth.authenticate')}}">
            <div class="navbar-item-inner-icon-wrapper flexbox">
                <ion-icon name="pie-chart-outline"></ion-icon>
            </div>
            <span class="link-text">Login</span>
        {% else %}
            <a class="navbar-item-inner flexbox-left" href="{{url_for('auth.logout')}}">
            <div class="navbar-item-inner-icon-wrapper flexbox">
                <ion-icon name="pie-chart-outline"></ion-icon>
            </div>
            <span class="link-text">Logout</span>
        {% endif %}
          
          
        </a>
      </li>
    </ul>
  </nav>

  <!--

    <div class="nav-menu" id="navMenu">
        <div class="nav-header">
            <div class="nav-toggle-container" onclick="toggleNav()">
                <button class="nav-toggle">☰</button>
            </div>
        </div>
        <ul class="nav-items">
            <li><a href="#">Home</a></li>
            <li><a href="#">About</a></li>
            <li><a href="#">Demandes</a></li>
        </ul>
        <div class="nav-footer">
            <div class="user-profile">
                {% if connected %}
                    <img src="{{pp}}" alt="User Profile Picture">
                {% else %}
                    <button class="login-button" onclick="window.location.href='/authenticate'">Login</button>
                {% endif %}
            </div>
        </div>
    </div>
-->
<main id="main" class="flexbox-col">
      {% with messages = get_flashed_messages() %}
        {% if messages %}
          <div id="overlay" class="overlay"></div>
            <div id="flash-message" class="flash-message">
              <span class="closebtn" onclick="closeFlashMessage();">&times;</span> 
      
              <ul class="flash_messages">
                  {% for message in messages %}
                      <li id="flash-message-content">{{ message }}</li>
                  {% endfor %}
              </ul>
            </div>
        {% endif %}
      {% endwith %}
        <h2>{% block section_title %}{% endblock %}</h2>
        {% block content %}{% endblock %}
    </main>
</body>
<script>
  window.onclick = function(event) {
    var flashMessageDiv = document.getElementById('flash-message');

    if (flashMessageDiv && event.target != flashMessageDiv && !flashMessageDiv.contains(event.target)) {
      closeFlashMessage()
    }

  }

  function closeFlashMessage() {
    var flashMessageDiv = document.getElementById('flash-message');
    var overlay = document.getElementById('overlay');

    flashMessageDiv.style.display = 'none';
    overlay.style.display = 'none';
}
</script>
</html>

    

templates/emprunt_bde.html
{% extends "base.html" %}

{% block section_title %}Services - Emprunt{% endblock %}
{% block custom_head %}<script src="{{ url_for('static', filename='scripts/emprunt_bde.js')}}"></script>{% endblock %}

{% block content %}
    
    <div>
        <p style="font-style: italic;">Rappel des règles pour emprunter :</p>
        <ul>
            <li>Ne louer qu'un seul appareil à la fois</li>
            <li>Ne pas dégrader l'appareil</li>
            <li>Rendre l'appareil dans son intégralité et propre</li>
        </ul>
    </div>
    <form method="post" action="{{ url_for('services.emprunt_bde') }}">
        {{ form.hidden_tag() }}
        <section>
            <div>
                <div>
                    <label for="item">Item:</label>
                    {{ form.item_select(class="form-control", placeholder="Enter your choice", id="item_input") }}
                    <label for="item" style="margin-left: 25px;">Sous : BDE/CLUB:</label>
                    {{ form.sous(class="form-control") }}
                </div>
                <!--
                <div id="custom_item_input" style="display: none; margin-left: 50px; flex-direction: row;">
                    <label for="custom_item_input">Nom de l'item à ajouter :</label>
                     form.custom_item_select(class="form-control", placeholder="Enter your choice", id="custom_item_input") 
                </div>-->
            </div>
            <div style="display: flex; flex-direction: row; margin-right: 50px;">
                <label for="date-debut" style="margin-right: 20px; margin-top: 10px;">Date de début de l'emprunt:</label>
                    {{ form.date_debut(class="form-control", id="start_date_input") }}
                <br>
                <label for="date-fin" style="margin-left: 25px; margin-top: 10px; margin-right: 20px;">Date de fin de l'emprunt:</label>
                    {{ form.date_fin(class="form-control", id="end_date_input") }}
            </div>
            <div id="duration_output" style="margin-top: 10px; margin-left: 50px; font-style: italic;"></div>
        </section>
        <section>
            <label for="item">La caution est:</label>
            {{ form.caution(class="form-control") }}
        </section>
        <section>
            {{ form.accept(class="form-control") }}
            <label for="item">{{ form.accept.label }}</label>
        </section>
        {{ form.submit(class="btn btn-primary") }}
        
    </form>

{% endblock %}

templates/index.html
{% extends "base.html" %}

{% block section_title %}Home{% endblock %}

{% block content %}
<p>Bienvenu.e.s sur le site de gestion de la logistique du BDE. Utiliser le menu à gauche pour naviguer !</p>

[ Contiendra le chatbot ]
{% endblock %}

templates/services.html
{% extends "base.html" %}

{% block section_title %}Services{% endblock %}

{% block content %}
<p>Différents services sont proposés en ligne :</p>
<ul>
    <li>
        <a href="{{ url_for('services.emprunt_bde') }}">Demander à emprunter</a>
    </li>
</ul>
{% endblock %}